Index: uspace/srv/net/tl/icmp/icmp.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp.c	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/tl/icmp/icmp.c	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -556,101 +590,211 @@
 		}
 	}
-	switch(header->type){
-		case ICMP_ECHOREPLY:
-			if(error){
-				return icmp_process_echo_reply(packet, header, type, code);
-			}else{
-				return icmp_process_echo_reply(packet, header, ICMP_ECHO, 0);
+
+	switch (header->type) {
+	case ICMP_ECHOREPLY:
+		if (error)
+			icmp_process_echo_reply(packet, header, type, code);
+		else
+			icmp_process_echo_reply(packet, header, ICMP_ECHO, 0);
+
+		return EOK;
+
+	case ICMP_ECHO:
+		if (error) {
+			icmp_process_echo_reply(packet, header, type, code);
+			return EOK;
+		}
+		
+		// do not send a reply if disabled
+		if (icmp_globals.echo_replying) {
+			addrlen = packet_get_addr(packet, &src, NULL);
+
+			// set both addresses to the source one (avoids the
+			// source address deletion before setting the
+			// destination one)
+			if ((addrlen > 0) && (packet_set_addr(packet, src, src,
+			    (size_t) addrlen) == EOK)) {
+				// send the reply
+				icmp_send_packet(ICMP_ECHOREPLY, 0, packet,
+				    header, 0, 0, 0, 0);
+				return EOK;
 			}
-		case ICMP_ECHO:
-			if(error){
-				return icmp_process_echo_reply(packet, header, type, code);
-			// do not send a reply if disabled
-			}else if(icmp_globals.echo_replying){
-				addrlen = packet_get_addr(packet, &src, NULL);
-				if((addrlen > 0)
-				// set both addresses to the source one (avoids the source address deletion before setting the destination one)
-					&& (packet_set_addr(packet, src, src, (size_t) addrlen) == EOK)){
-					// send the reply
-					icmp_send_packet(ICMP_ECHOREPLY, 0, packet, header, 0, 0, 0, 0);
-					return EOK;
-				}else{
-					return EINVAL;
+
+			return EINVAL;
+		}
+
+		return EPERM;
+
+	case ICMP_DEST_UNREACH:
+	case ICMP_SOURCE_QUENCH:
+	case ICMP_REDIRECT:
+	case ICMP_ALTERNATE_ADDR:
+	case ICMP_ROUTER_ADV:
+	case ICMP_ROUTER_SOL:
+	case ICMP_TIME_EXCEEDED:
+	case ICMP_PARAMETERPROB:
+	case ICMP_CONVERSION_ERROR:
+	case ICMP_REDIRECT_MOBILE:
+	case ICMP_SKIP:
+	case ICMP_PHOTURIS:
+		ip_received_error_msg(icmp_globals.ip_phone, -1, packet,
+		    SERVICE_IP, SERVICE_ICMP);
+		return EOK;
+
+	default:
+		return ENOTSUP;
+	}
+}
+
+/** Processes the received ICMP packet.
+ *
+ * Is used as an entry point from the underlying IP module.
+ * Releases the packet on error.
+ *
+ * @param device_id	The device identifier. Ignored parameter.
+ * @param[in,out] packet The received packet.
+ * @param receiver	The target service. Ignored parameter.
+ * @param[in] error	The packet error reporting service. Prefixes the
+ *			received packet.
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for the
+ *			icmp_process_packet() function.
+ */
+static int
+icmp_received_msg_local(device_id_t device_id, packet_t packet,
+    services_t receiver, services_t error)
+{
+	int rc;
+
+	rc = icmp_process_packet(packet, error);
+	if (rc != EOK)
+		return icmp_release_and_return(packet, rc);
+
+	return EOK;
+}
+
+/** Processes the generic client messages.
+ *
+ * @param[in] call	The message parameters.
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if the message is not known.
+ * @returns		Other error codes as defined for the packet_translate()
+ *			function.
+ * @returns		Other error codes as defined for the
+ *			icmp_destination_unreachable_msg_local() function.
+ * @returns		Other error codes as defined for the
+ *			icmp_source_quench_msg_local() function.
+ * @returns		Other error codes as defined for the
+ *			icmp_time_exceeded_msg_local() function.
+ * @returns		Other error codes as defined for the
+ *			icmp_parameter_problem_msg_local() function.
+ *
+ * @see icmp_interface.h
+ */
+static int icmp_process_message(ipc_call_t *call)
+{
+	packet_t packet;
+	int rc;
+
+	switch (IPC_GET_METHOD(*call)) {
+	case NET_ICMP_DEST_UNREACH:
+		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
+		return icmp_destination_unreachable_msg_local(0,
+		    ICMP_GET_CODE(call), ICMP_GET_MTU(call), packet);
+	case NET_ICMP_SOURCE_QUENCH:
+		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
+		return icmp_source_quench_msg_local(0, packet);
+	case NET_ICMP_TIME_EXCEEDED:
+		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
+		return icmp_time_exceeded_msg_local(0, ICMP_GET_CODE(call),
+		    packet);
+	case NET_ICMP_PARAMETERPROB:
+		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
+		return icmp_parameter_problem_msg_local(0, ICMP_GET_CODE(call),
+		    ICMP_GET_POINTER(call), packet);
+	default:
+		return ENOTSUP;
+	}
+}
+
+/** Assigns a new identifier for the connection.
+ *
+ * Fills the echo data parameter with the assigned values.
+ *
+ * @param[in,out] echo_data The echo data to be bound.
+ * @returns		Index of the inserted echo data.
+ * @returns		EBADMEM if the echo_data parameter is NULL.
+ * @returns		ENOTCONN if no free identifier have been found.
+ */
+static int icmp_bind_free_id(icmp_echo_ref echo_data)
+{
+	icmp_param_t index;
+
+	if (!echo_data)
+		return EBADMEM;
+
+	// from the last used one
+	index = icmp_globals.last_used_id;
+	do {
+		index++;
+		// til the range end
+		if (index >= ICMP_FREE_IDS_END) {
+			// start from the range beginning
+			index = ICMP_FREE_IDS_START - 1;
+			do {
+				index++;
+				// til the last used one
+				if (index >= icmp_globals.last_used_id) {
+					// none found
+					return ENOTCONN;
 				}
-			}else{
-				return EPERM;
-			}
-		case ICMP_DEST_UNREACH:
-		case ICMP_SOURCE_QUENCH:
-		case ICMP_REDIRECT:
-		case ICMP_ALTERNATE_ADDR:
-		case ICMP_ROUTER_ADV:
-		case ICMP_ROUTER_SOL:
-		case ICMP_TIME_EXCEEDED:
-		case ICMP_PARAMETERPROB:
-		case ICMP_CONVERSION_ERROR:
-		case ICMP_REDIRECT_MOBILE:
-		case ICMP_SKIP:
-		case ICMP_PHOTURIS:
-			ip_received_error_msg(icmp_globals.ip_phone, -1, packet, SERVICE_IP, SERVICE_ICMP);
-			return EOK;
-		default:
-			return ENOTSUP;
-	}
-}
-
-int icmp_process_echo_reply(packet_t packet, icmp_header_ref header, icmp_type_t type, icmp_code_t code){
-	int reply_key;
-	icmp_reply_ref reply;
-
-	// compute the reply key
-	reply_key = ICMP_GET_REPLY_KEY(header->un.echo.identifier, header->un.echo.sequence_number);
-	pq_release_remote(icmp_globals.net_phone, packet_get_id(packet));
-	// lock the globals
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-	// find the pending reply
-	reply = icmp_replies_find(&icmp_globals.replies, reply_key);
-	if(reply){
-		// set the result
-		reply->result = type;
-		// notify the waiting fibril
-		fibril_condvar_signal(&reply->condvar);
-	}
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
-	return EOK;
-}
-
-int icmp_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
-	ERROR_DECLARE;
-
-	packet_t packet;
-
-	*answer_count = 0;
-	switch(IPC_GET_METHOD(*call)){
-		case NET_TL_RECEIVED:
-			if(! ERROR_OCCURRED(packet_translate_remote(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
-				ERROR_CODE = icmp_received_msg(IPC_GET_DEVICE(call), packet, SERVICE_ICMP, IPC_GET_ERROR(call));
-			}
-			return ERROR_CODE;
-		case NET_ICMP_INIT:
-			return icmp_process_client_messages(callid, * call);
-		default:
-			return icmp_process_message(call);
-	}
-	return ENOTSUP;
-}
-
-int icmp_process_client_messages(ipc_callid_t callid, ipc_call_t call){
-	ERROR_DECLARE;
-
+			} while(icmp_echo_data_find(&icmp_globals.echo_data,
+			    index) != NULL);
+
+			// found, break immediately
+			break;
+		}
+	} while (icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
+
+	echo_data->identifier = index;
+	echo_data->sequence_number = 0;
+
+	return icmp_echo_data_add(&icmp_globals.echo_data, index, echo_data);
+}
+
+/** Processes the client messages.
+ *
+ * Remembers the assigned identifier and sequence numbers.
+ * Runs until the client module disconnects.
+ *
+ * @param[in] callid	The message identifier.
+ * @param[in] call	The message parameters.
+ * @returns EOK.
+ *
+ * @see icmp_interface.h
+ * @see icmp_api.h
+ */
+static int icmp_process_client_messages(ipc_callid_t callid, ipc_call_t call)
+{
 	bool keep_on_going = true;
-//	fibril_rwlock_t			lock;
 	ipc_call_t answer;
 	int answer_count;
 	size_t length;
-	struct sockaddr * addr;
+	struct sockaddr *addr;
 	ipc_callid_t data_callid;
 	icmp_echo_ref echo_data;
-	int res;
+	int rc = EOK;
 
 	/*
@@ -658,27 +802,22 @@
 	 *  - Answer the first NET_ICMP_INIT call.
 	 */
-	res = EOK;
 	answer_count = 0;
 
-//	fibril_rwlock_initialize(&lock);
-
 	echo_data = (icmp_echo_ref) malloc(sizeof(*echo_data));
-	if(! echo_data){
+	if (!echo_data)
 		return ENOMEM;
-	}
 
 	// assign a new identifier
 	fibril_rwlock_write_lock(&icmp_globals.lock);
-	res = icmp_bind_free_id(echo_data);
+	rc = icmp_bind_free_id(echo_data);
 	fibril_rwlock_write_unlock(&icmp_globals.lock);
-	if(res < 0){
+	if (rc < 0) {
 		free(echo_data);
-		return res;
-	}
-
-	while(keep_on_going){
-
+		return rc;
+	}
+
+	while (keep_on_going) {
 		// answer the call
-		answer_call(callid, res, &answer, answer_count);
+		answer_call(callid, rc, &answer, answer_count);
 
 		// refresh data
@@ -689,38 +828,50 @@
 
 		// process the call
-		switch(IPC_GET_METHOD(call)){
-			case IPC_M_PHONE_HUNGUP:
-				keep_on_going = false;
-				res = EHANGUP;
+		switch (IPC_GET_METHOD(call)) {
+		case IPC_M_PHONE_HUNGUP:
+			keep_on_going = false;
+			rc = EHANGUP;
+			break;
+		
+		case NET_ICMP_ECHO:
+			if (!async_data_write_receive(&data_callid, &length)) {
+				rc = EINVAL;
 				break;
-			case NET_ICMP_ECHO:
-//				fibril_rwlock_write_lock(&lock);
-				if(! async_data_write_receive(&data_callid, &length)){
-					res = EINVAL;
-				}else{
-					addr = malloc(length);
-					if(! addr){
-						res = ENOMEM;
-					}else{
-						if(! ERROR_OCCURRED(async_data_write_finalize(data_callid, addr, length))){
-							fibril_rwlock_write_lock(&icmp_globals.lock);
-							res = icmp_echo(echo_data->identifier, echo_data->sequence_number, ICMP_GET_SIZE(call), ICMP_GET_TIMEOUT(call), ICMP_GET_TTL(call), ICMP_GET_TOS(call), ICMP_GET_DONT_FRAGMENT(call), addr, (socklen_t) length);
-							fibril_rwlock_write_unlock(&icmp_globals.lock);
-							free(addr);
-							if(echo_data->sequence_number < UINT16_MAX){
-								++ echo_data->sequence_number;
-							}else{
-								echo_data->sequence_number = 0;
-							}
-						}else{
-							res = ERROR_CODE;
-						}
-					}
-				}
-//				fibril_rwlock_write_unlock(&lock);
+			}
+			
+			addr = malloc(length);
+			if (!addr) {
+				rc = ENOMEM;
 				break;
-			default:
-				res = icmp_process_message(&call);
+			}
+			
+			rc = async_data_write_finalize(data_callid, addr,
+			    length);
+			if (rc != EOK) {
+				free(addr);
+				break;
+			}
+
+			fibril_rwlock_write_lock(&icmp_globals.lock);
+			rc = icmp_echo(echo_data->identifier,
+			    echo_data->sequence_number, ICMP_GET_SIZE(call),
+			    ICMP_GET_TIMEOUT(call), ICMP_GET_TTL(call),
+			    ICMP_GET_TOS(call), ICMP_GET_DONT_FRAGMENT(call),
+			    addr, (socklen_t) length);
+			fibril_rwlock_write_unlock(&icmp_globals.lock);
+
+			free(addr);
+
+			if (echo_data->sequence_number < UINT16_MAX)
+				echo_data->sequence_number++;
+			else
+				echo_data->sequence_number = 0;
+
+			break;
+
+		default:
+			rc = icmp_process_message(&call);
 		}
+
 	}
 
@@ -729,81 +880,56 @@
 	icmp_echo_data_exclude(&icmp_globals.echo_data, echo_data->identifier);
 	fibril_rwlock_write_unlock(&icmp_globals.lock);
-	return res;
-}
-
-int icmp_process_message(ipc_call_t * call){
-	ERROR_DECLARE;
-
+
+	return rc;
+}
+
+/** Processes the ICMP message.
+ *
+ * @param[in] callid	The message identifier.
+ * @param[in] call	The message parameters.
+ * @param[out] answer	The message answer parameters.
+ * @param[out] answer_count The last parameter for the actual answer in the
+ *			answer parameter.
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if the message is not known.
+ *
+ * @see icmp_interface.h
+ * @see IS_NET_ICMP_MESSAGE()
+ */
+int
+icmp_message_standalone(ipc_callid_t callid, ipc_call_t *call,
+    ipc_call_t *answer, int *answer_count)
+{
 	packet_t packet;
-
-	switch(IPC_GET_METHOD(*call)){
-		case NET_ICMP_DEST_UNREACH:
-			if(! ERROR_OCCURRED(packet_translate_remote(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
-				ERROR_CODE = icmp_destination_unreachable_msg(0, ICMP_GET_CODE(call), ICMP_GET_MTU(call), packet);
-			}
-			return ERROR_CODE;
-		case NET_ICMP_SOURCE_QUENCH:
-			if(! ERROR_OCCURRED(packet_translate_remote(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
-				ERROR_CODE = icmp_source_quench_msg(0, packet);
-			}
-			return ERROR_CODE;
-		case NET_ICMP_TIME_EXCEEDED:
-			if(! ERROR_OCCURRED(packet_translate_remote(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
-				ERROR_CODE = icmp_time_exceeded_msg(0, ICMP_GET_CODE(call), packet);
-			}
-			return ERROR_CODE;
-		case NET_ICMP_PARAMETERPROB:
-			if(! ERROR_OCCURRED(packet_translate_remote(icmp_globals.net_phone, &packet, IPC_GET_PACKET(call)))){
-				ERROR_CODE = icmp_parameter_problem_msg(0, ICMP_GET_CODE(call), ICMP_GET_POINTER(call), packet);
-			}
-			return ERROR_CODE;
-		default:
-			return ENOTSUP;
-	}
-}
-
-int icmp_release_and_return(packet_t packet, int result){
-	pq_release_remote(icmp_globals.net_phone, packet_get_id(packet));
-	return result;
-}
-
-int icmp_bind_free_id(icmp_echo_ref echo_data){
-	icmp_param_t index;
-
-	if(! echo_data){
-		return EBADMEM;
-	}
-	// from the last used one
-	index = icmp_globals.last_used_id;
-	do{
-		++ index;
-		// til the range end
-		if(index >= ICMP_FREE_IDS_END){
-			// start from the range beginning
-			index = ICMP_FREE_IDS_START - 1;
-			do{
-				++ index;
-				// til the last used one
-				if(index >= icmp_globals.last_used_id){
-					// none found
-					return ENOTCONN;
-				}
-			}while(icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
-			// found, break immediately
-			break;
-		}
-	}while(icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
-	echo_data->identifier = index;
-	echo_data->sequence_number = 0;
-	return icmp_echo_data_add(&icmp_globals.echo_data, index, echo_data);
-}
+	int rc;
+
+	*answer_count = 0;
+	switch (IPC_GET_METHOD(*call)) {
+	case NET_TL_RECEIVED:
+		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
+		    IPC_GET_PACKET(call));
+		if (rc != EOK)
+			return rc;
+		return icmp_received_msg_local(IPC_GET_DEVICE(call), packet,
+		    SERVICE_ICMP, IPC_GET_ERROR(call));
+	
+	case NET_ICMP_INIT:
+		return icmp_process_client_messages(callid, * call);
+	
+	default:
+		return icmp_process_message(call);
+	}
+
+	return ENOTSUP;
+}
+
 
 /** Default thread for new connections.
  *
- *  @param[in] iid The initial message identifier.
- *  @param[in] icall The initial message call structure.
- *
- */
-static void tl_client_connection(ipc_callid_t iid, ipc_call_t * icall)
+ * @param[in] iid The initial message identifier.
+ * @param[in] icall The initial message call structure.
+ *
+ */
+static void tl_client_connection(ipc_callid_t iid, ipc_call_t *icall)
 {
 	/*
@@ -813,5 +939,5 @@
 	ipc_answer_0(iid, EOK);
 	
-	while(true) {
+	while (true) {
 		ipc_call_t answer;
 		int answer_count;
@@ -828,6 +954,10 @@
 		    &answer_count);
 		
-		/* End if said to either by the message or the processing result */
-		if ((IPC_GET_METHOD(call) == IPC_M_PHONE_HUNGUP) || (res == EHANGUP))
+		/*
+		 * End if told to either by the message or the processing
+		 * result.
+		 */
+		if ((IPC_GET_METHOD(call) == IPC_M_PHONE_HUNGUP) ||
+		    (res == EHANGUP))
 			return;
 		
@@ -839,22 +969,18 @@
 /** Starts the module.
  *
- *  @param argc The count of the command line arguments. Ignored parameter.
- *  @param argv The command line parameters. Ignored parameter.
- *
- *  @returns EOK on success.
- *  @returns Other error codes as defined for each specific module start function.
- *
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for each specific module
+ *			start function.
  */
 int main(int argc, char *argv[])
 {
-	ERROR_DECLARE;
+	int rc;
 	
 	/* Start the module */
-	if (ERROR_OCCURRED(tl_module_start_standalone(tl_client_connection)))
-		return ERROR_CODE;
-	
-	return EOK;
+	rc = tl_module_start_standalone(tl_client_connection);
+	return rc;
 }
 
 /** @}
  */
+
Index: uspace/srv/net/tl/icmp/icmp.h
===================================================================
--- uspace/srv/net/tl/icmp/icmp.h	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/tl/icmp/icmp.h	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -28,90 +28,81 @@
 
 /** @addtogroup icmp
- *  @{
+ * @{
  */
 
 /** @file
- *  ICMP module.
+ * ICMP module.
  */
 
-#ifndef __NET_ICMP_H__
-#define __NET_ICMP_H__
+#ifndef NET_ICMP_H_
+#define NET_ICMP_H_
 
 #include <fibril_synch.h>
 
 #include <net/icmp_codes.h>
+#include <net/packet.h>
 #include <adt/int_map.h>
 #include <icmp_header.h>
 
 /** Type definition of the ICMP reply data.
- *  @see icmp_reply
+ * @see icmp_reply
  */
-typedef struct icmp_reply	icmp_reply_t;
+typedef struct icmp_reply icmp_reply_t;
 
 /** Type definition of the ICMP reply data pointer.
- *  @see icmp_reply
+ * @see icmp_reply
  */
-typedef icmp_reply_t *	icmp_reply_ref;
+typedef icmp_reply_t *icmp_reply_ref;
 
 /** Type definition of the ICMP global data.
- *  @see icmp_globals
+ * @see icmp_globals
  */
-typedef struct icmp_globals	icmp_globals_t;
+typedef struct icmp_globals icmp_globals_t;
 
 /** Pending replies map.
- *  Maps message identifiers to the pending replies.
- *  Sending fibril waits for its associated reply event.
- *  Receiving fibril sets the associated reply with the return value and signals the event.
+ *
+ * Maps message identifiers to the pending replies.
+ * Sending fibril waits for its associated reply event.
+ * Receiving fibril sets the associated reply with the return value and signals
+ * the event.
  */
 INT_MAP_DECLARE(icmp_replies, icmp_reply_t);
 
 /** Echo specific data map.
- *  The identifier is used in the future semi-remote calls instead of the ICMP phone.
+ *
+ * The identifier is used in the future semi-remote calls instead of the ICMP
+ * phone.
  */
 INT_MAP_DECLARE(icmp_echo_data, icmp_echo_t);
 
-/** ICMP reply data.
- */
-struct icmp_reply{
-	/** Reply result.
-	 */
+/** ICMP reply data. */
+struct icmp_reply {
+	/** Reply result. */
 	int result;
-	/** Safety lock.
-	 */
+	/** Safety lock. */
 	fibril_mutex_t mutex;
-	/** Received or timeouted reply signaling.
-	 */
+	/** Received or timeouted reply signaling. */
 	fibril_condvar_t condvar;
 };
 
-/** ICMP global data.
- */
-struct	icmp_globals{
-	/** IP module phone.
-	 */
+/** ICMP global data. */
+struct icmp_globals {
+	/** IP module phone. */
 	int ip_phone;
-	/** Packet dimension.
-	 */
+	/** Packet dimension. */
 	packet_dimension_t packet_dimension;
-	/** Networking module phone.
-	 */
+	/** Networking module phone. */
 	int net_phone;
-	/** Indicates whether ICMP error reporting is enabled.
-	 */
+	/** Indicates whether ICMP error reporting is enabled. */
 	int error_reporting;
-	/** Indicates whether ICMP echo replying (ping) is enabled.
-	 */
+	/** Indicates whether ICMP echo replying (ping) is enabled. */
 	int echo_replying;
-	/** The last used identifier number.
-	 */
+	/** The last used identifier number. */
 	icmp_param_t last_used_id;
-	/** The budled modules assigned echo specific data.
-	 */
+	/** The budled modules assigned echo specific data. */
 	icmp_echo_data_t echo_data;
-	/** Echo timeout locks.
-	 */
+	/** Echo timeout locks. */
 	icmp_replies_t replies;
-	/** Safety lock.
-	 */
+	/** Safety lock. */
 	fibril_rwlock_t lock;
 };
@@ -121,3 +112,2 @@
 /** @}
  */
-
Index: uspace/srv/net/tl/icmp/icmp_module.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp_module.c	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/tl/icmp/icmp_module.c	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -28,17 +28,20 @@
 
 /** @addtogroup icmp
- *  @{
+ * @{
  */
 
 /** @file
- *  ICMP standalone module implementation.
- *  Contains skeleton module functions mapping.
- *  The functions are used by the module skeleton as module specific entry points.
- *  @see module.c
+ * ICMP standalone module implementation.
+ * Contains skeleton module functions mapping.
+ * The functions are used by the module skeleton as module specific entry points.
+ * @see module.c
  */
+
+#include "icmp.h"
+#include "icmp_module.h"
 
 #include <async.h>
 #include <stdio.h>
-#include <err.h>
+#include <errno.h>
 #include <ipc/ipc.h>
 #include <ipc/services.h>
@@ -47,52 +50,43 @@
 #include <net/packet.h>
 #include <net_interface.h>
+
 #include <tl_local.h>
 
-#include "icmp.h"
-#include "icmp_module.h"
+/** ICMP module global data. */
+extern icmp_globals_t icmp_globals;
 
-/** ICMP module global data.
- */
-extern icmp_globals_t	icmp_globals;
-
-/** Starts the ICMP module.
- *  Initializes the client connection serving function, initializes the module, registers the module service and starts the async manager, processing IPC messages in an infinite loop.
- *  @param[in] client_connection The client connection processing function. The module skeleton propagates its own one.
- *  @returns EOK on successful module termination.
- *  @returns Other error codes as defined for the arp_initialize() function.
- *  @returns Other error codes as defined for the REGISTER_ME() macro function.
- */
-int tl_module_start_standalone(async_client_conn_t client_connection){
-	ERROR_DECLARE;
-
+int tl_module_start_standalone(async_client_conn_t client_connection)
+{
 	ipcarg_t phonehash;
+	int rc;
 
 	async_set_client_connection(client_connection);
 	icmp_globals.net_phone = net_connect_module();
-	if(icmp_globals.net_phone < 0){
+	if (icmp_globals.net_phone < 0)
 		return icmp_globals.net_phone;
-	}
-	ERROR_PROPAGATE(pm_init());
-	if(ERROR_OCCURRED(icmp_initialize(client_connection))
-		|| ERROR_OCCURRED(REGISTER_ME(SERVICE_ICMP, &phonehash))){
-		pm_destroy();
-		return ERROR_CODE;
-	}
+
+	rc = pm_init();
+	if (rc != EOK)
+		return rc;
+	
+	rc = icmp_initialize(client_connection);
+	if (rc != EOK)
+		goto out;
+
+	rc = REGISTER_ME(SERVICE_ICMP, &phonehash);
+	if (rc != EOK)
+		goto out;
 
 	async_manager();
 
+out:
 	pm_destroy();
-	return EOK;
+	return rc;
 }
 
-/** Processes the ICMP message.
- *  @param[in] callid The message identifier.
- *  @param[in] call The message parameters.
- *  @param[out] answer The message answer parameters.
- *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
- *  @returns EOK on success.
- *  @returns Other error codes as defined for the icmp_message() function.
- */
-int tl_module_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
+int
+tl_module_message_standalone(ipc_callid_t callid, ipc_call_t *call,
+    ipc_call_t *answer, int *answer_count)
+{
 	return icmp_message_standalone(callid, call, answer, answer_count);
 }
Index: uspace/srv/net/tl/icmp/icmp_module.h
===================================================================
--- uspace/srv/net/tl/icmp/icmp_module.h	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/tl/icmp/icmp_module.h	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -28,36 +28,21 @@
 
 /** @addtogroup icmp
- *  @{
+ * @{
  */
 
 /** @file
- *  ICMP module functions.
- *  The functions are used as ICMP module entry points.
+ * ICMP module functions.
+ * The functions are used as ICMP module entry points.
  */
 
-#ifndef __NET_ICMP_MODULE_H__
-#define __NET_ICMP_MODULE_H__
+#ifndef NET_ICMP_MODULE_H_
+#define NET_ICMP_MODULE_H_
 
 #include <async.h>
 #include <ipc/ipc.h>
 
-/** Initializes the ICMP module.
- *  @param[in] client_connection The client connection processing function. The module skeleton propagates its own one.
- *  @returns EOK on success.
- *  @returns ENOMEM if there is not enough memory left.
- */
-int icmp_initialize(async_client_conn_t client_connection);
-
-/** Processes the ICMP message.
- *  @param[in] callid The message identifier.
- *  @param[in] call The message parameters.
- *  @param[out] answer The message answer parameters.
- *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
- *  @returns EOK on success.
- *  @returns ENOTSUP if the message is not known.
- *  @see icmp_interface.h
- *  @see IS_NET_ICMP_MESSAGE()
- */
-int icmp_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count);
+extern int icmp_initialize(async_client_conn_t);
+extern int icmp_message_standalone(ipc_callid_t, ipc_call_t *, ipc_call_t *,
+    int *);
 
 #endif
